"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TencentSmsService = void 0;
const common_1 = require("@nestjs/common");
const tencentcloud_sdk_nodejs_1 = require("tencentcloud-sdk-nodejs");
const constant_1 = require("./constant");
const lodash_1 = require("lodash");
let TencentSmsService = class TencentSmsService {
    constructor(options) {
        this.options = options;
        this.smsSdkAppId = this.options.SmsSdkAppid;
        this.smsTemplateID = this.options.TemplateID;
        this.smsTemplateSign = this.options.TemplateSign;
        this._smsClient = new tencentcloud_sdk_nodejs_1.sms.v20190711.Client(Object.assign(Object.assign({}, lodash_1.pick(this.options, ['profile', 'credential'])), { region: 'ap-guangzhou' }));
    }
    getSmsPackagesStatistics(page = 1, page_size = 10) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this._smsClient
                .SmsPackagesStatistics({
                SmsSdkAppid: this.smsSdkAppId,
                Limit: page_size,
                Offset: (page - 1) * page_size,
            })
                .then((data) => data.SmsPackagesStatisticsSet, () => []);
        });
    }
    sendSms(phone, code, minute) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this._smsClient
                .SendSms({
                PhoneNumberSet: [`+86${phone}`],
                TemplateID: this.smsTemplateID,
                Sign: this.smsTemplateSign,
                TemplateParamSet: [code, minute],
                SmsSdkAppid: this.smsSdkAppId,
            })
                .then((data) => data.SendStatusSet.find(Boolean), () => false);
        });
    }
};
TencentSmsService = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject(constant_1.TENCENT_SMS_MODULE_OPTIONS)),
    __metadata("design:paramtypes", [Object])
], TencentSmsService);
exports.TencentSmsService = TencentSmsService;
