import type { FactoryProvider, ModuleMetadata, Type } from '@nestjs/common';

export interface TencentSmsFactory {
  createTencentSmsConfiguration():
    | Promise<TencentSmsModuleOptions>
    | TencentSmsModuleOptions;
}

export interface TencentSmsModuleAsyncOptions
  extends Pick<ModuleMetadata, 'imports'> {
  useExisting?: Type<TencentSmsFactory>;
  useClass?: Type<TencentSmsFactory>;
  useFactory?: (
    ...args: any[]
  ) => TencentSmsModuleOptions | Promise<TencentSmsModuleOptions>;
  inject?: FactoryProvider['inject'];
}

export interface TencentSmsModuleOptions {
  global?: boolean;
  TemplateSign: string;
  TemplateID: string;
  SmsSdkAppid: string;
  credential: {
    secretId: string;
    secretKey: string;
  };
  profile: {
    httpProfile: {
      endpoint: string;
    };
  };
}
